# hey Emacs, its -*- rpm-spec -*-
# $Id: ruby,v 1.58 2003/08/21 12:15:49 ab Exp $

%define _configure_target --build=%_target_platform

Name: ruby
Version: 1.8
%define subver %(echo %version |cut -d. -f1,2)
Release: alt9

Summary: Object Oriented Script Language
License: Dual: GPL and Ruby
Group: Development/Ruby
Url: http://www.ruby-lang.org/
AutoReq: yes, noshell
Requires: %name-stdlibs = %version-%release

Source: ftp://ftp.ruby-lang.org/pub/ruby/%name-%version.tar.gz
Source1: http://www.rubycentral.com/faq/rubyfaq_a4.pdf
Source2: http://www.rubycentral.com/downloads/files/ProgrammingRuby-0.3a.tar.bz2
Source3: http://www.approximity.com/euruko03/slides/tobias/peters.pdf
Source4: http://www.approximity.com/euruko03/slides/hal/rubyesque.tar.gz
Source5: http://www.ruby-lang.org/cgi-bin/cvsweb.cgi/~checkout~/shim/ruby16/doc/features-ruby18.txt
Patch1: ruby-1.7.3-fhs-vendor-alt.patch
Patch2: ruby-1.7.3-mkmf-cxx-alt.patch
Patch3: fileutils.rb.patch
Patch4: ruby-1.8-rexml.patch

Buildrequires:	flex, bison, tk-devel, libtinfo-devel, libreadline-devel, libdb4-devel
BuildRequires: libgdbm-devel, findutils, cpp, zlib-devel, ncurses-devel, openssl-devel

%package doc
Summary: Documentation for the powerful language Ruby
Group: Development/Ruby
Requires: %name = %version-%release
AutoReq: no

%package -n lib%name-devel
Summary: Development for the powerful language Ruby
Group: Development/Ruby
Requires: lib%name = %version-%release
Obsoletes: %name-devel
Provides: %name-devel

%package -n lib%name-devel-static
Summary: Development for the powerful language Ruby (static library)
Group: Development/Ruby
Requires: lib%name-devel = %version-%release
Obsoletes: %name-devel-static
Provides: %name-devel-static

%package -n lib%name
Summary: Ruby as dynamic library
Group: Development/Ruby

%package stdlibs
Summary: Standard library for Ruby
Group: Development/Ruby
Prereq: lib%name = %version-%release
Obsoletes: ruby-testunit, ruby-openssl
Provides: ruby-testunit

%package stdlibs-tk
Summary: Tcl/Tk standard library bindings for Ruby
Group: Development/Ruby
Prereq: %name-stdlibs = %version-%release

%description
Ruby is the interpreted scripting language for quick and
easy object-oriented programming.  It has many features to
process text files and to do system management tasks (as in
Perl).  It is simple, straight-forward, and extensible.

%description doc
This package provides documentation for the Ruby programming
language. It includes documentation for standard Ruby libraries
and HTML version of the 'Programming Ruby' book.

%description -n lib%name-devel
Ruby is the entrepred scripting language for quick and
easy object-oriented programming. This package includes
development headers needed for embedding Ruby
in other applications or compiling Ruby extensions.

%description -n lib%name-devel-static
Ruby is the entrepred scripting language for quick and
easy object-oriented programming. This package includes
statically linked Ruby library needed for embedding Ruby
in other applications.

%description -n lib%name
Ruby is the entrepred scripting language for quick and
easy object-oriented programming. This package includes
libruby dymanically linked library suited for embedding Ruby
in other applications. File system structure for standard 
library of Ruby modules and classes also provided by this 
package. You may want to install %name-stdlibs as well to get
access to Ruby standard classes library.

%description stdlibs
Standard library of Ruby modules and classes.

%description stdlibs-tk
Tcl/Tk bindings for Ruby. This is an extension modules
for Ruby standard library which provides easy access to
Tcl/Tk.

%prep
%setup -q -n ruby
%patch1 -p1 -b .fhs
#%%patch2 -p1 -b .mkmf_cxx
pushd lib
%patch3 -p0 -b .symlinks
popd
%patch4 -p1

%build
autoconf
%configure --enable-shared --program-prefix= --program-suffix= \
	    --with-dbm-type=db --with-sitedir=%_prefix/local/share/ruby/site_ruby

# Hack to pass mkmf checks for socket as it tries to run tests in extensions
# linked against libruby.so which isn't in a LD's path yet
export LD_LIBRARY_PATH=%_builddir/%name
%__make
%__make test

%install
find . -type d -name CVS | xargs rm -rf
%__make DESTDIR=%buildroot install

# Install third-party documentation
%__mkdir_p euruko03
%__cp %SOURCE1 .
%__cp %SOURCE5 .
%__cp %SOURCE3 euruko03/GarbageCollectionInExtensions.pdf
tar xzf %SOURCE4 -C euruko03

%__mkdir_p %buildroot%_datadir/%name/vendor_ruby/%subver
%__mkdir_p %buildroot%_libdir/%name/vendor_ruby/%subver/%{_target_cpu}-%{_host_os}

%__mkdir_p extensions
# Search documentation for extensions
(find ext -type f -name '*.txt*' -o -name 'test*'
 find ext \( -type f -name 'README*' \) -o \( -type d -name 'sample' -o -name 'doc' \)
 ) | grep -v CVS | ./miniruby -pn -Ilib -rEnglish -e '
require "ftools"
require "fileutils"
$LAST_READ_LINE.chomp!
begin
    File.makedirs("extensions/"+File.dirname($LAST_READ_LINE))
rescue
end

FileUtils.cp_r $LAST_READ_LINE, "extensions/#{$LAST_READ_LINE}"
'
(%__tar xfj %SOURCE2 ; cd Pro*; %__rm -rf xml)

echo "VENDOR_SPECIFIC=true" >%buildroot%_datadir/%name/vendor_ruby/vendor-specific.rb

# generate file lists for appropriate packages
# 1. Generate full file list
(cd %buildroot ; find usr/lib/%name ! -type d -printf "/%%p\n") > %name.list
(cd %buildroot ; find usr/lib/%name   -type d -printf "%%%%dir /%%p\n") >> %name.list
(cd %buildroot ; find usr/share/%name ! -type d -printf "/%%p\n") >> %name.list
(cd %buildroot ; find usr/share/%name   -type d -printf "%%%%dir /%%p\n") >> %name.list

# 2. Remove components of lib%name-devel[-static]
./miniruby -ni -Ilib -rEnglish -e 'print if !Regexp.new("%{_target_cpu}-%{_host_os}/.*[ha]\$").match $LAST_READ_LINE' %name.list

%__cp %name.list %name-tk.list
%__cp %name.list %name-core.list

# 3. Generate list for %name-stdlibs-tcltk
./miniruby -ni -Ilib -rEnglish -e 'print if /tcl|tk/.match $LAST_READ_LINE' %name-tk.list

# 4. Generate list for %name-stdlibs-core
./miniruby -ni -Ilib -rEnglish -e '
    VENDOR_SPECIFIC=true unless defined?(VENDOR_SPECIFIC)
    require "./rbconfig"
    require "ftools"
    include Config
    re_array = []
    ["sitearchdir", "sitelibdir", "archdir", "rubylibdir"].each do |dir|
	components = CONFIG[dir].split("/")
	0.upto components.length-1 do |idx|
	    re_array.push components[0..-1-idx].join("/")
	end
    end
    regexp = "%%dir (" + re_array.join("|") + ")\$"
    print if Regexp.new(regexp).match $LAST_READ_LINE' %name-core.list

# 5. Generate list for %name-stdlibs
cat %name-tk.list %name-core.list %name.list | sort | uniq -u > %name-stdlibs.list

# 6. Generate RPM macros for libruby-devel
%__mkdir -p %buildroot%_sysconfdir/rpm/macros.d
./miniruby -e '
    VENDOR_SPECIFIC=true unless defined?(VENDOR_SPECIFIC)
    require "./rbconfig"
    include Config
    ["sitearchdir", "sitelibdir", "archdir", "rubylibdir"].each do |dir|
	puts "%%%%ruby_%%s	#{CONFIG[dir]}" %% dir.gsub(/ruby/,"")
    end
' >%buildroot%_sysconfdir/rpm/macros.d/ruby

echo "%%ruby_configure	ruby -rvendor-specific extconf.rb" >>%buildroot%_sysconfdir/rpm/macros.d/ruby

# Workaround error in instruby.rb which thinks libruby.so.1.8 is manpage :)
rm -f %buildroot/%_man8dir/*

# This is a hack but we really don't need to bytecompile 
# Python comparison sample in the Ruby manual
unset RPM_PYTHON

%clean

%post -n lib%name
%post_ldconfig

%postun -n lib%name
%postun_ldconfig

%files stdlibs -f %name-stdlibs.list

%files stdlibs-tk -f %name-tk.list

%files
%doc README LEGAL COPYING* ToDo GPL LGPL  ChangeLog features-ruby18.txt
%_bindir/*
%_mandir/*/*

%files -n lib%name -f %name-core.list
%_libdir/*.so.*

%files doc
%docdir %_docdir/%name-%version
%doc README.* rubyfaq_a4.pdf ProgrammingRuby* extensions doc sample euruko03

%files -n lib%name-devel
%_libdir/%name/%subver/%_target_cpu-%_host_os/*.h
%_libdir/*.so
%_sysconfdir/rpm/macros.d/%name

%files -n lib%name-devel-static
%_libdir/*.a

%changelog
* Thu Aug 21 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt9
- Snapshot as of 2003/08/21

* Wed Aug 06 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt8
- Fixed:
  + REXML now falls back to iconv(3) when there is no native 
    support for specified encoding (ab)

* Tue Aug 05 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt7
- Final Ruby 1.8.0 + post-release fixes from CVS

* Sat Aug 02 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt6
- 2003/08/02
- OpenSSL support integrated, thus ruby-openssl is obsolete now

* Tue Jul 22 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt5
- Snapshot as of 2003/07/22

* Mon Jul 07 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt4
- Test::Unit is included into stdlibs, ruby-stdlibs package 
  obsoletes ruby-testunit now and provides it for backward 
  compatibility

* Sun Jul 06 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt3
- Tag release in BTE
- Remove tinfo patch for curses, integrated into upstream

* Sat Jul 05 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt2
- 1.8 CVS snapshot (2003/07/05)

* Sun Jun 29 2003 Alexander Bokovoy <ab@altlinux.ru> 1.8-alt1
- 1.8 CVS snapshot (2003/06/29)
- Patches updated, CGI patch excluded (already in upstream)
- Add %_libdir/%name/vendor_ruby/%subver/%{_target_cpu}-%{_host_os} to the list
  of owned directories for stdlibs-core
- Enhance dependencies between subpackages:
    + lib%name is a base package, everything else requires it (through a chain),
      it also owns a Ruby subtree directories
    + %name-stdlibs prerequires lib%name
    + %name-stdlibc-tk prerequires %name-stdlibs
    + every third-party Ruby package *should* prerequire lib%name
      if it is installable into Ruby subtree
- Clean up spec file:
    + Fix miniruby calls to use non-Perlish variable notation only
- Removed:
    + %name-stdlib-core package merged with lib%name
- Major review of packaged documentation:
    + Ruby FAQ is now in A4 PDF
    + Hal Fulton's "Rubyesque API" from EuRuKo03
    + Tobias Peters' "Garbage in Ruby Extensions" from EuRuKo03
    + Features of Ruby 1.8 since Ruby 1.6 from ruby-shim project

* Tue Dec 10 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt9
- Fixed:
    + Readline extension was lost due wrong check for libtermcap instead
      of libtinfo
    + fileutils.rb incorrect behaviour for symlinks (mouse@altlinux.ru)

* Fri Nov 22 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt8
- Fixed:
    + IRB code to not use #initialize publicly as it is a private method
      in Ruby 1.7 since 2002-11-14.
- Removed:
    + Proxy-Authorization support in Net::HTTP patch (integrated into upstream)

* Tue Nov 19 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt7
- Changed:
    + Installation splitted between %_datadir and %_libdir
      in order to be more conformant to FHS
    + Directory structure is stored in %name-stdlibs-core package
    + vendordir/vendorarchdir added as /usr/{lib,share}/ruby/vendor_ruby
      and site-specific dirs moved to /usr/local
- Fixed:
    + curses modules build fixed
    + mkmf.rb to successuly configure C++ exetnsions

* Tue Oct 29 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt6
- Removed:
    + misc/*.el as now they are part of (X)Emacs prog-modes
- Added:
    + Patch to fix CGI and Cookies to follow 1.7's split() behaviour
    + Gdbm module support
- Fixed:
    + Getaddrinfo detection code in mkmf
- ToDo:
    + Fix mkmf to run run_test() against locally compiled libruby.so
      when dealing with extensions, not against (non-)existent system-wide one

* Sat Oct 26 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt5
- News snapshot (2002/10/26)
- Fixed BuildReq to allow build of gdbm module
- Group changed to Development/Ruby
- Remove ruby-stdlibs-win32ole as it seems tend to not work

* Wed Oct 09 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt4
- New snapshot (2002/10/09)
- Changed:
    + Emacs support moved to %name-doc and placed in %_docdir/%name-%version/misc
      unless XEmacs and GNU Emacs maintaining teams decide where and how
      to put third-party program modes. Also, XEmacs already has (an outdated)
      ruby-mode.

* Thu Sep 26 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 1.7.3-alt3
- rebuilt with tcl 8.4

* Thu Sep 19 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt2
- New snapshot (2002/09/19)
- Added:
    + Patch to support proxy authorization in Net::HTTP (Alexander Bokovoy)
    + Win32ole support using Wine as ruby-stdlibs-win32ole
    + db module using libdb4
- Fixed:
    + Build requires to include Readline

* Mon Sep 09 2002 Alexander Bokovoy <ab@altlinux.ru> 1.7.3-alt1
- Initial build of 1.7.x
- Standard library splitted off to ruby-stdlibs
- More libification:
    + Dynamic library splitted off to libruby
    + ruby-devel renamed to libruby-devel
    + ruby-devel-static renamed to libruby-devel-static
- Tcl/Tk extensions work now and split off to ruby-stdlibs-tk
- Documentation extended

* Wed Aug  7 2002 Grigory Milev <week@altlinux.ru> 1.6.7-alt1
- minor spec cleanup

* Tue May 07 2002 Alexander Bokovoy <ab@altlinux.ru> 1.6.7-alt1
- 1.6.7 + post release fixes

* Fri Feb 08 2002 Alexander Bokovoy <ab@altlinux.ru> 1.6.6-alt3
- Dependencies for ruby-doc package refined

* Mon Jan 28 2002 Stanislav Ievlev <inger@altlinux.ru> 1.6.6-alt2
- rebuild with new python

* Wed Dec 26 2001 Alexander Bokovoy <ab@altlinux.ru> 1.6.6-alt1
- 1.6.6
- Removed:
    + mkmf patch (integrated into upstream)
    + Regexp patch (integrated into upstream)

* Thu Dec 20 2001 Alexander Bokovoy <ab@altlinux.ru> 1.6.5-alt6
- Fixed:
    + mkmf patch updated to one from Nobu Nakada

* Thu Dec 13 2001 Alexander Bokovoy <ab@altlinux.ru> 1.6.5-alt5
- Fixed:
    + Regexp UTF-8 handling (backport from 1.7.x)
    + %_libdir/ruby/site_ruby/%subver added

* Wed Dec 05 2001 Alexander Bokovoy <ab@altlinux.ru> 1.6.5-alt4
- Updated:
    + Programming Ruby up to 0.3a
    + URL for Ruby FAQ
- Fixed:
    + Programming Ruby html structure

* Fri Nov 30 2001 Alexander Bokovoy <ab@altlinux.ru> 1.6.5-alt3
- Fixed:
    + mkmf to allow full usage of $(DESTDIR), this is required to
      properly build extension packages

* Tue Oct 16 2001 Alexander Bokovoy <ab@altlinux.ru>   1.6.5-alt2
- Enable shared library build
- Move static library to devel-static

* Fri Sep 28 2001 Stanislav Ievlev <inger@altlinux.ru> 1.6.5-alt1
- 1.6.5

* Thu Jun 14 2001 Stanislav Ievlev <inger@altlinux.ru> 1.6.4-alt1
- 1.6.4

* Mon May 28 2001 Stanislav Ievlev <inger@altlinux.ru> 1.6.3-alt3
- New patches from Mandrake.

* Mon Apr 23 2001 Stanislav Ievlev <inger@altlinux.ru> 1.6.3-alt2
- Fix extentions. Thanks to Pixel.

* Wed Apr 18 2001 Stanislav Ievlev <inger@altlinux.ru> 1.6.3-alt1
- Up to 1.6.3

* Tue Jan 16 2001 AEN <aen@logic.ru>
- RE adaptations

* Mon Nov 27 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-4mdk
- build again full optflags

* Wed Nov  8 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-3mdk
- build without -fomit-frame-pointer for time being
- capitalize summaries

* Mon Oct  2 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-2mdk
- fix mispelling

* Thu Sep 28 2000 Pixel <pixel@mandrakesoft.com> 1.6.1-1mdk
- new version
- remove "--with-default-kcode=none", not more needed
- remove setting optflags to -O2, ruby doesn't crashes any more

* Tue Sep 19 2000 Pixel <pixel@mandrakesoft.com> 1.6.0-1mdk
- new version

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-6mdk
- add packager

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-5mdk
- nicer site-start.d/ruby.el (use add-to-list)

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-4mdk
- fix missing %%config

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-3mdk
- use %_sysconfdir/emacs/site-start.d for the ruby-mode.el

* Fri Aug 18 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-2mdk
- rebuild (fredlsux)

* Fri Aug 18 2000 Pixel <pixel@mandrakesoft.com> 1.4.6-1mdk
- new version
- remove menu

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.4.5-6mdk
- automatically added BuildRequires

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-5mdk
- rebuild with clean clean_menus

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-4mdk
- macroization
- BM

* Thu Jul 13 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-3mdk
- fix %%URL

* Sun Jun 25 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-2mdk
- rebuild (src.rpm got lost :( )

* Fri Jun 23 2000 Pixel <pixel@mandrakesoft.com> 1.4.5-1mdk
- new version

* Wed Jun 14 2000 Pixel <pixel@mandrakesoft.com> 1.4.4-1mdk
- new version

* Mon Apr 10 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-6mdk
- fix group for doc

* Mon Mar 27 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-5mdk
- add menu

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-4mdk
- new group + cleanup

* Wed Feb 16 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-3mdk
- build with no charset conversion (was kanji :)

* Mon Feb 14 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-2mdk
- added the reference manual and FAQ in doc
- moved the lib/README in ext

* Mon Feb 14 2000 Pixel <pixel@mandrakesoft.com> 1.4.3-1mdk
- mandrake adaptation and spliting in -/doc/extensions

* Wed Dec 08 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.3

* Mon Sep 20 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.2 (Sep 18)

* Fri Sep 17 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.2

* Tue Aug 17 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.4.0

* Fri Jul 23 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- 2nd release
- Updated to version 1.2.6(15 Jul 1999)
- striped %prefix/bin/ruby

* Mon Jun 28 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.2.6(21 Jun 1999)

* Wed Apr 14 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.2.5

* Fri Apr 09 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- Updated to version 1.2.4

* Fri Dec 25 1998 Toru Hoshina <hoshina@best.com>
- Version up to 1.2 stable.

* Fri Nov 27 1998 Toru Hoshina <hoshina@best.com>
- Version up to 1.1c9.

* Thu Nov 19 1998 Toru Hoshina <hoshina@best.com>
- Version up to 1.1c8, however it appear short life :-P

* Fri Nov 13 1998 Toru Hoshina <hoshina@best.com>
- Version up.




